package com.futu.course.common.utils;


import cn.hutool.core.util.RandomUtil;

import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @className: CpaUtil
 * @Description:
 * @author: zhangxiong
 * @date: 2021/12/29/0029 16:06
 */
public class BestUtil {

    private static final BigDecimal ZERO = new BigDecimal(0);
    private static final DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyMMddHHmmss");
    private static final int idFormatter = 100;
    public static final BigDecimal ZERO_BUY = new BigDecimal("0.01");
    public static final BigDecimal ARRIVAL_PRICE = new BigDecimal("500");
    public static int handleDivide(Integer dividend, Integer divisor) {
        int result = 0;
        if (divisor > 0 && dividend > 0) {
            BigDecimal divide = BigDecimal.valueOf(dividend).divide(BigDecimal.valueOf(divisor), 2, BigDecimal.ROUND_HALF_UP);
            return divide.scaleByPowerOfTen(2).intValue();
        }
        return result;
    }

    public static String geneOrderNum(Long userId){
        StringBuilder format = new StringBuilder(LocalDateTime.now().format(formatter));
        format.append(RandomUtil.randomNumbers(4));
        format.append(userId%idFormatter);
        return format.toString();
    }
    /**
     *
     * @param val
     * @return 大于 0 true,小于等于0false
     */
    public static boolean GTZero(BigDecimal val){
        if(val == null){
            return false;
        }
        return ZERO.compareTo(val) < 0;
    }
    /**
     *
     * @param val
     * @return 大于等于 0 true,小于0false
     */
    public static boolean GEZero(BigDecimal val){
        if(val == null){
            return false;
        }
        return ZERO.compareTo(val) <= 0;
    }

    public static String desensitizationMobile(String mobile){
        if(mobile != null && mobile.length() > 10){
            String suffix = mobile.substring(6);
            String prefix = mobile.substring(0, 3);
            return prefix +"***" +suffix;
        }
        return "";
    }
}
