package com.futu.course.user.controller;

import com.futu.course.user.domain.UserAddress;
import com.futu.course.user.service.impl.UserAddressServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

/**
 * @author "杨旭朋"
 * @ClassName: UserAddressController
 * @date 2025年05月12日 08:44
 */
@RestController
@RequestMapping("userAddress")
public class UserAddressController {
    @Autowired
    UserAddressServiceImpl userAddressService;
    @GetMapping("UserAddressList")
    public List<UserAddress> userArrayList(){
        return userAddressService.UserAddressList();
    }
    @GetMapping("selUserDefault")
    public UserAddress selUserDefault(){
        return userAddressService.selUserDefault();
    }
    @PostMapping("addUserAddress")
    public String  addUserAddress(@RequestBody UserAddress userAddress){
        return userAddressService.addUserAddress(userAddress);
    }
    @PostMapping("AltUserAddress")
    public String updateUserAddress(@RequestBody UserAddress userAddress) {
       return userAddressService.updateUserAddress(userAddress);
    }
    @PostMapping("DelUserAddress")
    public String DelUserAddress(@RequestParam("id") Long id) {
        return userAddressService.DelUserAddress(id);
    }
    @PostMapping("AltUserAddressDefault")
    public String AltUserAddressDefault(@RequestParam("id") Long id) {
        return userAddressService.AltUserAddressDefault(id);
    }
}
